#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <hamsandwich>

#define PLUGIN "(BRUXOS): Skins 4fun"
#define VERSION "1.6"
#define AUTHOR "fbaixista. & willian"

enum
{
	admin = 0, girl, master, supremo, fundador, vip, max_flags
}

new cvar[6], g_acesso_flags[30]
new g_acesso_skins[30][max_flags]

/*-------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------*/
// Configuraes das models

// Skin adm
#define model_skin_admTR "admin_tr"
#define model_skin_admCT "admin_ct"

// Skin adm Girl
#define model_skin_admgirlTR "admin_girl_tr"
#define model_skin_admgirlCT "admin_girl_ct"

// Skin Master
#define model_skin_masterTR "master_tr"
#define model_skin_masterCT "master_ct"

// Skin Supremo
#define model_skin_supremoTR "supremo_tr"
#define model_skin_supremoCT "supremo_ct"

// Skin Fundador
#define model_skin_fundadorTR "fundador_tr"
#define model_skin_fundadorCT "fundador_ct"

// Skin vip
#define model_skin_vipTR "bruxos_vip_TR"
#define model_skin_vipCT "bruxos_vip_CT"

/*-------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------*/

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	RegisterHam(Ham_Spawn, "player", "player_spawn")
	register_event("ResetHUD", "reset_hud", "b")
	
	cvar[0]	= register_cvar("flag_skin_admin", "q")
	cvar[1]	= register_cvar("flag_skin_girl", "r")
	cvar[2]	= register_cvar("flag_skin_master", "p")
	cvar[3]	= register_cvar("flag_skin_supremo", "o")
	cvar[4]	= register_cvar("flag_skin_fundador", "m")
	cvar[5]	= register_cvar("flag_skin_vip", "s")
}

public plugin_cfg()
{
	new cfg_dir[32]
	get_configsdir(cfg_dir, charsmax(cfg_dir))
	server_cmd("exec %s/skins_4fun.cfg", cfg_dir)
	
	get_pcvar_string(cvar[0], g_acesso_skins[admin], charsmax(g_acesso_skins))
	get_pcvar_string(cvar[1], g_acesso_skins[girl], charsmax(g_acesso_skins))
	get_pcvar_string(cvar[2], g_acesso_skins[master], charsmax(g_acesso_skins))
	get_pcvar_string(cvar[3], g_acesso_skins[supremo], charsmax(g_acesso_skins))
	get_pcvar_string(cvar[4], g_acesso_skins[fundador], charsmax(g_acesso_skins))
	get_pcvar_string(cvar[5], g_acesso_skins[vip], charsmax(g_acesso_skins))
	
	g_acesso_flags[admin] = read_flags(g_acesso_skins[admin])
	g_acesso_flags[girl] = read_flags(g_acesso_skins[girl])
	g_acesso_flags[master] = read_flags(g_acesso_skins[master])
	g_acesso_flags[supremo] = read_flags(g_acesso_skins[supremo])
	g_acesso_flags[fundador] = read_flags(g_acesso_skins[fundador])
	g_acesso_flags[vip] = read_flags(g_acesso_skins[vip])
}

public plugin_precache()
{
	precache_player_model(model_skin_admTR)
	precache_player_model(model_skin_admCT)
	precache_player_model(model_skin_admgirlTR)
	precache_player_model(model_skin_admgirlCT)
	precache_player_model(model_skin_masterTR)
	precache_player_model(model_skin_masterCT)
	precache_player_model(model_skin_supremoTR)
	precache_player_model(model_skin_supremoCT)
	precache_player_model(model_skin_fundadorTR)
	precache_player_model(model_skin_fundadorCT)
	precache_player_model(model_skin_vipTR)
	precache_player_model(model_skin_vipCT)	
}

public player_spawn(id) set_skin_player(id)
public reset_hud(id) set_skin_player(id)

public set_skin_player(id)
{
	if(!is_user_alive(id) || !is_user_connected(id))
		return PLUGIN_HANDLED

	new iTime = get_user_team(id)
	
	// Skins para Admins, CT e TR
	if(get_user_flags(id) & g_acesso_flags[admin]) 
		cs_set_user_model(id, iTime == 1 ? model_skin_admTR : model_skin_admCT)
	
	// Skins para Girls, CT e TR
	if(get_user_flags(id) & g_acesso_flags[girl])
		cs_set_user_model(id, iTime == 1 ? model_skin_admgirlTR : model_skin_admgirlCT)

	// Skins para Master, CT e TR
	if(get_user_flags(id) & g_acesso_flags[master])
		cs_set_user_model(id, iTime == 1 ? model_skin_masterTR : model_skin_masterCT)
	
	// Skins para Supremo, CT e TR
	if(get_user_flags(id) & g_acesso_flags[supremo])
		cs_set_user_model(id, iTime == 1 ? model_skin_supremoTR : model_skin_supremoCT)
	
	// Skins para Fundador, CT e TR
	if(get_user_flags(id) & g_acesso_flags[fundador])
		cs_set_user_model(id, iTime == 1 ? model_skin_fundadorTR : model_skin_fundadorCT)
		
	// Skins para vip, CT e TR
	if(get_user_flags(id) & g_acesso_flags[vip])
		cs_set_user_model(id, iTime == 1 ? model_skin_vipTR : model_skin_vipCT)		

	return PLUGIN_HANDLED
}

precache_player_model(const modelname[]) 
{
	static longname[128] 
	formatex(longname, charsmax(longname), "models/player/%s/%s.mdl", modelname, modelname)  	
	precache_model(longname) 
	
	copy(longname[strlen(longname)-5], charsmax(longname) - (strlen(longname)-5), "T.mdl") 
	if (file_exists(longname)) precache_model(longname) 
} 
